import { renderless, api } from '@opentinyvue/vue-renderless/switch/vue';
import { defineComponent, props, setup } from '@opentinyvue/vue-common';
import '@opentinyvue/vue-theme/switch/index.css';
import { IconLoadingShadow } from '@opentinyvue/vue-icon';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  emits: ["change", "update:modelValue"],
  props: [].concat(props, ["modelValue", "trueValue", "falseValue", "disabled", "mini", "tabindex", "showText", "beforeChange", "displayOnly", "loading"]),
  components: {
    IconLoading: IconLoadingShadow()
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return !_vm.state.isDisplayOnly ? _c("span", {
    class: [_vm.state.wrapClasses, _vm.state.showText ? "tiny-switch__text" : ""],
    attrs: {
      "tabindex": _vm.tabindex
    },
    on: {
      "click": _vm.toggle,
      "keydown": [function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "space", 32, $event.key, [" ", "Spacebar"])) return null;
        return _vm.toggle.apply(null, arguments);
      }, function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")) return null;
        return _vm.toggle.apply(null, arguments);
      }]
    }
  }, [_c("span", {
    class: _vm.state.innerClasses
  }, [!_vm.mini && _vm.state.showText && !_vm.loading ? _c("div", [_vm.state.currentValue === _vm.trueValue ? _vm._t("open", function() {
    return [_vm._v("ON")];
  }) : _vm._e(), _vm.state.currentValue === _vm.falseValue ? _vm._t("close", function() {
    return [_vm._v("OFF")];
  }) : _vm._e()], 2) : _vm._e()]), _c("span", {
    staticClass: "tiny-switch__button"
  }, [_vm.loading ? _c("icon-loading", {
    class: [_vm.state.currentValue === _vm.trueValue ? "tiny-switch__on-loading" : "tiny-switch__off-loading", _vm.mini ? "tiny-switch__loading-size" : ""]
  }) : _vm._e(), _vm.state.currentValue === _vm.trueValue && !_vm.loading ? _vm._t("active-icon") : _vm._e(), _vm.state.currentValue === _vm.falseValue && !_vm.loading ? _vm._t("inactive-icon") : _vm._e()], 2)]) : _c("span", [_vm.state.currentValue === _vm.trueValue ? _vm._t("open", function() {
    return [_vm._v(_vm._s(_vm.t("yes")))];
  }) : _vm._e(), _vm.state.currentValue === _vm.falseValue ? _vm._t("close", function() {
    return [_vm._v(_vm._s(_vm.t("no")))];
  }) : _vm._e()], 2);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
